<template>
  <div>
    <v-skeleton-loader
      v-if="compraId === 0"
      type="table-heading, image"
    ></v-skeleton-loader>
    <div v-else>
      <div class="d-flex justify-space-between">
        <div style="width: 100px;">
          <v-select
            v-model="perPage"
            :label="$t('totalVisible')"
            :items="listPerPage"
            @change="getDetalleCompra"
            dense
          />
        </div>
        <div class="d-flex justify-end">
          <v-btn
            class="mt-2 mr-4"
            color="primary"
            rounded
            small
            @click="refreshTable"
            :disabled="loading"
          >
            <v-icon>mdi-refresh</v-icon>
            {{ $t('actualizar') }}
          </v-btn>
          <v-pagination
            v-model="currentPage"
            :disabled="loading"
            :length="lastPage"
            :total-visible="8"
          />
        </div>
      </div>
      <v-data-table
        v-model="selected"
        :headers="headers"
        :items="detalleCompraData"
        item-key="id"
        class="elevation-1"
        disable-pagination
        hide-default-footer
        dense
        :loading="loading"
      >

        <template v-slot:item.actions="{ item }">
          <v-btn
            small
            icon
            @click="eliminarDetalle(item.id)"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
          <v-btn
            small
            icon
            @click="editarDetalle(item)"
          >
            <v-icon>mdi-pencil</v-icon>
          </v-btn>
        </template>
      </v-data-table>
    </div>
    <v-dialog v-model="modal" max-width="400" transition="dialog-bottom-transition" persistent>
      <DetalleCompraForm
      :detalleCompra="detalleCompra"
        @onDetalleCompraGuardada="detalleGuardado"
        @onCancelarGuardar="cancelarGuardado"
      />
    </v-dialog>
  </div>
</template>

<script>
import DetalleCompraServicio from '@/store/services/DetalleCompraServicio'
import DetalleCompraForm from './DetalleCompraForm.vue'
export default {
  name: "DetalleCompra",
  components: {
    DetalleCompraForm
  },
  props: {
    compraId: {
      type: Number,
      required: false,
      default: 0
    }
  },
  data() {
    return {
      listPerPage: [5, 10, 15, this.$t('todo')],
      perPage: 5,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      detalleCompraData: [],
      selected: [],
      loading: false,
      modal: false,
      detalleCompra: null
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getDetalleCompra() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        compra_id: this.compraId,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      try {
        let response = await DetalleCompraServicio.index(params)
        this.detalleCompraData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getDetalleCompra();
      else this.currentPage = 1;
    },
    editarMaterial(value) {
      console.log(value)
      this.$emit('onEditarMaterial', value)
    },
    async guardarDetalle(detalle) {
      try {
        this.loading = true
        await DetalleCompraServicio.update(detalle.id, this.form)
        .then(() => {
          this.refreshTable()
        })
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    editarDetalle(value) {
      this.modal = true
      this.detalleCompra = value
    },
    async eliminarDetalle(detalleId) {
      try {
        this.loading = true
        await DetalleCompraServicio.remove(detalleId)
        .then(() => {
          this.refreshTable()
        })
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    detalleGuardado() {
      this.detalleCompra = null
      this.modal = false
      this.refreshTable()
    },
    cancelarGuardado() {
      this.detalleCompra = null
      this.modal = false
    }
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('id'),
          value: 'material.id',
          sortable: false,
        },
        {
          text: this.$t('codigo'),
          value: 'material.codigo',
          sortable: false,
        },
        {
          text: this.$t('descripcion'),
          value: 'material.descripcion',
          sortable: false,
        },
        {
          text: this.$t('unidManejo'),
          value: 'material.unid_manejo',
          sortable: false,
        },
        {
          text: this.$t('cantidad'),
          value: 'cantidad',
          sortable: false,
          align: 'center'
        },
        {
          text: this.$t('marca'),
          value: 'material.marca',
          sortable: false,
        },
        {
          text: this.$t('precio'),
          value: 'precio',
          sortable: false,
        },
        {
          text: this.$t('total'),
          value: 'precio_total',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getDetalleCompra()
    },
    compraId: {
      immediate: true,
      handler() {
        if (this.compraId > 0) {
          this.getDetalleCompra()
        }
      }
    }
  },
  created() {
  }
}
</script>

<style>

</style>
